#ifndef RAY_HXX
#define RAY_HXX

#include "Vec3f.hxx"

class Ray
{
public:
  Ray();
  Ray(const Vec3f& org, const Vec3f& dir);
  ~Ray();
  Ray(const Ray& r);
  Ray& operator=(const Ray& r);
  
  const Vec3f& origin() const;
  const Vec3f& direction() const;
  float t() const;
private:
  Vec3f m_org; //!< ray origin
  Vec3f m_dir; //!< ray direction
  float m_t;   //!< current/maximum hit distance
};

inline std::ostream &operator<<(std::ostream &o,const Ray &ray)
{ o << "Ray [" << ray.origin() << "+t*" << ray.direction() << "]"; return o; }

#endif
